export class SimpleKernel {
    constructor(db: import("abstract-level/types/abstract-level.js").AbstractLevel<any, Uint8Array, Uint8Array>, opts?: {
        secret?: SecretBin;
    });
    ready: boolean;
    _secret: null | SecretBin;
    db: import("abstract-level/types/abstract-level.js").AbstractLevel<any, Uint8Array, Uint8Array>;
    store: Store;
    rpc: SimpleRPC;
    repo: Repo;
    get pk(): string;
    boot(): Promise<void>;
    __loading: Promise<void>;
    mergeStrategy(block: import("picofeed").Block, self: Repo): boolean | Promise<boolean>;
    feed(limit?: any): Promise<Feed>;
    _checkReady(): void;
    seq(): Promise<number>;
    dispatch(patch: any, loudFail?: boolean): Promise<Feed>;
    collection(name: string): import("@telamon/picostore").Memory;
    createBlock(root: string, payload: object, branch?: Feed): Promise<Feed>;
    spawnWire(): {
        readonly name: string;
        id: any;
        onmessage: any;
        readonly opened: Promise<any>;
        readonly closed: any;
        postMessage(msg: any, flags: any): Promise<any>;
        readonly isActive: boolean;
        readonly isClosed: boolean;
        open(handler: any): any;
        close(err?: any): void;
        readonly other: any;
    };
    ondisconnect(peer: any): void;
    onconnect(node: any): Promise<void>;
    onquery(params: any, reply: any): Promise<Feed[]>;
    onblocks(feed: any): Promise<Feed>;
    _networkResolveFeed(feed: any, loudFail: any): Promise<void>;
    $connections(): any;
    halt(): Promise<void>;
    _onstoreevent(events: {
        event: string;
        payload: any;
    }[]): void;
}
export type SecretBin = import('picofeed').SecretBin;
export type PublicHex = import('picofeed').PublicHex;
export type BinaryLevel = import('picorepo').BinaryLevel;
import { Store } from '@telamon/picostore';
import { SimpleRPC } from './simple-rpc.js';
import { Repo } from 'picorepo';
import { Feed } from 'picofeed';
